// PoVRay 3.6 Scene File " ... .pov"
// created by   ...  
// Date:   ...
//--------------------------------------------------------------------------
#version 3.5;
global_settings {  assumed_gamma 1.0 }
#default{ finish{ ambient 0.1 diffuse 0.9 }} 
//--------------------------------------------------------------------------
#include "colors.inc"
#include "textures.inc"
#include "glass.inc"
#include "metals.inc"
#include "golds.inc"
#include "stones.inc"
#include "woods.inc"
#include "shapes.inc"
#include "shapes2.inc"
#include "functions.inc"
#include "math.inc"
#include "transforms.inc"
//--------------------------------------------------------------------------
// camera ------------------------------------------------------------------
#declare Camera_0 = camera {/*ultra_wide_angle*/ angle 75      // front view
                            location  <0.0 , 1.0 ,-3.0>
                            right     x*image_width/image_height
                            look_at   <0.0 , 1.0 , 0.0>}
#declare Camera_1 = camera {/*ultra_wide_angle*/ angle 90   // diagonal view
                            location  <2.0 , 2.5 ,-3.0>
                            right     x*image_width/image_height
                            look_at   <0.0 , 1.0 , 0.0>}
#declare Camera_2 = camera {/*ultra_wide_angle*/ angle 90  //right side view
                            location  <3.0 , 1.0 , 0.0>
                            right     x*image_width/image_height
                            look_at   <0.0 , 1.0 , 0.0>}
#declare Camera_3 = camera {/*ultra_wide_angle*/ angle 90        // top view
                            location  <0.0 , 3.0 ,-0.001>
                            right     x*image_width/image_height
                            look_at   <0.0 , 1.0 , 0.0>}
camera{Camera_0}
// sun ---------------------------------------------------------------------
light_source{< -3000, 3000, -3000> color White}
// sky ---------------------------------------------------------------------
sky_sphere { pigment { gradient <0,1,0>
                       color_map { [0.00 rgb <0.6,0.7,1.0>]
                                   [0.35 rgb <0.0,0.1,0.8>]
                                   [0.65 rgb <0.0,0.1,0.8>]
                                   [1.00 rgb <0.6,0.7,1.0>] 
                                 } 
                       scale 2         
                     } // end of pigment
           } //end of skysphere
// ground ------------------------------------------------------------------
plane{ <0,1,0>, 0 
       texture{ pigment{ color rgb <0.7,0.5,0.3>}
              //normal { bumps 0.75 scale 0.025}
              //finish { phong 0.1}
              } // end of texture
     } // end of plane
//--------------------------------------------------------------------------
//---------------------------- objects in scene ----------------------------
//--------------------------------------------------------------------------

                    
/*
Variablen:
Clock von 0..1 mit 0.05 increment
Wa: Drehwinkel   Schwungrad von 0 bis 2 Pi= Clock *2; 
Ws: Drehwinkel   Schwungrad in Grad
Xa: X-Pos        Schwungrad = COS(PI()*W);
ya: y-Pos        Schwungrad = SIN(PI()*W);
Xf: X-Pos        Zylinderdrehpunkt = const;
yf: y-Pos        Zylinderdrehpunkt = const;      
Xr: X-Diff       = Xf-Xa
Yr: Y-Diff       = Yf-Ya
Wr: Winkel Zyl. im Bogenmass = atan(yr/xr)
Wf: Winkel Zyl. in Grad      = Wr /(1/180)
Kl: Lnge Kolben
Kd: Durchmesser Kolben
*/   

#declare Wa  = clock *2;    
#declare Ws  = 180 * Wa;

#declare Ya  = sin(pi*Wa);
#declare Xa  = cos(pi*Wa);
#declare Yf  = 0;
#declare Xf  = 40.5/6.5;
#declare Yr  = Yf-Ya;
#declare Xr  = Xf-Xa;
#declare Wr  = atan(Yr/Xr);   
#declare Wf  = (180/pi) * Wr;
#declare Kl  = 4.5;
#declare Kd  = 0.1;
   
#debug concat("Value Wa is:",str(Wa,8,5),"\n")
#debug concat("Value Ya is:",str(Ya,8,5),"\n")
#debug concat("Value Xa is:",str(Xa,8,5),"\n")
#debug concat("Value Yr is:",str(Yr,8,5),"\n")
#debug concat("Value Xr is:",str(Xr,8,5),"\n")
#debug concat("Value Wf is:",str(Wf,8,5),"\n")
                    
                                                            
#declare Spiegel=object{
  difference{
    box {<0,0,0>,<12.5,69,12.5> }                       // Spiegel Vollmaterial
    union {
      cylinder {<6.25,-1,6.25>,<6.25,10,6.25>,1.5}      // untere Sackbohrung / Gewinde
      box {<-1,12,-20>,<5,32,20> }                      // Ausschnitt SChwungrad
      cylinder {<-20,22,6.25>,<20,22,6.25>,2.5}         // Bohrung Kurbelwelle
      cylinder {<-30,49.5,4>,<30,49.5,4>,1}             // Steuerbohrung rechts
      cylinder {<-30,49.5,8.5>,<30,49.5,8.5>,1}         // Steuerbohrung links
      cylinder {<-20,62.5,6.25>,<20,62.5,6.25>,1.6}     // Befestigungsbohrung Zylinder             
    }
  }
  pigment { color <.8,0,0,.5>}
}

                     
#declare Zylinder=object{
  union{
    difference {
      box {<0,0,0>,<12.5,52,12.5> }                       // Zylinder Vollmaterial
      union {
        cylinder {<6.25,-1,6.25>,<6.25,38.1,6.25>,3.75}   // Verdrngerbohrung
        cone {<6.25,38,6.25>, 3.75,<6.25,40,6.25> ,0}     // Kegel Bohrerspitze
        cylinder {<6.25,32,6.25>,<20,32,6.25>,1}          // Steuerbohrung        
        cylinder {<-20,45.5,6.25>,<20,45.5,6.25>,1.6}     // Befestigungsbohrung Zylinder             
        cylinder {<6.25,13,6.25>,<20,13,6.25>,3.175}      // Langloch
        box      {<6.25,-1,3.075>,<20,13,9.425> }         // Ausschnitt Langloch      
      }  
    }
    cylinder {<-2,45.5,6.25>,<28,45.5,6.25>,1.58 pigment { color Yellow }}       // Achse Zylinder
  }
  pigment { color <0,.8,0,.99>}
  translate y*-45.5
  translate x*-6.25
  translate z*-6.25
  rotate x*-Wf
}


#declare Kolben=object{
  difference {    
    cylinder {<0,0,0>,<0,25.5,0>,3.74}                    // Vollmaterial
    union {
      cylinder {<-20,6,0>,<20,6,0>,2}                     // Bohring Kurbelzapfen                  
    }  
  }
  pigment { color Gray }
  translate y*-6
  rotate x*-Wf
  translate y* ( Xa * 40.5/6.5)
  translate z* ( Ya * -40.5/6.5)
}


#declare Kurbelwelle=object {
   union {
     cylinder {<-1,0,0>,<24.3,0,0>,2.49      }          // Welle
     cylinder {<21,0,0>,<24,0,0>,9           }          // Scheibe
     cylinder {<20.95,6.5,0>,<34,6.5,0>,1.95 }          // Zapfen
     
   }
   pigment { color Yellow }
   rotate x*Ws
}   


#declare Schwungrad=object{
  union{
    difference {    
      union {
        cylinder {<0,0,0>,<12.67,0,0>,10.335}           // Vollmaterial Schwungrad
        cylinder {<0,0,0>,<10.67,0,0>,12.335}           // Absatz 
      }                                                 
      cylinder {<-10,0,0>,<20,0,0>,2.5}                 // Bohrung Kurbelwelle 
    }
    object { Kurbelwelle }
  }  
  pigment { color Blue }
  translate x*-12.67
}
                      
                      
#declare Cross=object {    
  union {
    sphere   { <0,0,0>, .5 }
    cylinder { <-40,0,0>,<40,0,0>,.3 }
    cylinder { <0,-40,0>,<0,40,0>,.3 }
    cylinder { <0,0,-40>,<0,0,40>,.3 }
  } 
  pigment  { color <1,0,0> }
}  
  
                     
union {
  //object { Cross }                     

  object { 
           Spiegel 
           translate z*-6.25
  }
  
  
  object { 
           Zylinder 
           translate y*62.5
           translate x*-6.26
  }
  
  
  object { 
           Kolben            
           translate x*-6.25
           translate y*22
 
  }
     
  
  object { 
           Schwungrad 
           rotate y*180
           translate x*12.51           
           translate y*22

  }
  
  scale .03
  //rotate y* (-90)  
  rotate y* (-90-35)  
  //rotate x* -9
}